use strict;
use Socket;

#non-object
my $crlf="\r\n";
my $allhead=

 "User-Agent: Mozilla/4.0 (compatible; MSIE 5.0; Windows 98; DigExt)";

sub request{
 my ($server,$data)=@_;
#add begin
 my $port=80;
 if ($server=~s/:(\d+)//) {
  $port=$1;
 }
#add end
 my $proto=getprotobyname('tcp');
 socket(Sock,AF_INET,SOCK_STREAM,$proto); # || die ("!socket");
 my $ip=gethostbyname($server);
 if (!$ip) {
  return "!server";
 }

#modify
 my $sin=sockaddr_in($port,$ip);

 if (!connect(Sock,$sin)) {
  return "!connect";
 }
 send(Sock,$data,0);
 shutdown(Sock,1);
 my $response='';
 my $buf;
 do {
  recv(Sock,$buf,8192,0);
  $response.=$buf;
 } while (length($buf)>0);
 shutdown(Sock,0);
 close(Sock);
 return $response;
}

sub http {
 my ($server,$head,$head2,$data)=@_;
 if (!($head2 eq '')) {
  $head2.=$crlf;
 }
 return request($server,$head.$crlf.$allhead.$crlf.'Host: '.$server.$crlf.$head2.$crlf.$data);
}

sub cookies {
 my ($cook)=@_;
 if (!($cook eq '')) {
  $cook='Cookie: '.$cook.$crlf;
 }
 return $cook;
}

sub refer {
 my ($r)=@_;
 if (!($r eq '')) {
  $r='Referer: '.$r.$crlf;
 }
 return $r;
}

sub post {
 my ($server,$url,$cook,$data,$refe)=@_;
 return http($server,'POST '.$url.' HTTP/1.0',cookies($cook).refer($refe)."Content-type: application/x-www-form-urlencoded".$crlf."Content-length: ".length($data),$data);
}

sub get {
 my ($server,$url,$cook)=@_;
 return http($server,'GET '.$url.' HTTP/1.0',cookies($cook),"");
}

sub headbody {
 my ($q)=@_;
 $q=~/^([\x00-\xff]*?)(\r\n\r\n|\n\n)([\x00-\xff]*)$/m;
 return ($1,$3);
}

sub getcookie {
 my ($p)=@_;
 my @q=split(/;/,$p);
 $q[0]=~s/^[ \t\r\n]+//;
 $q[0]=~s/[ \t\r\n]+$//;
 @q=split(/=/,$q[0]);
 return $q[0]."=".$q[1];
}

sub head {
 my ($p)=@_;
 my @hb=headbody($p);
 return $hb[0];
}

sub body {
 my ($p)=@_;
 my @hb=headbody($p);
 return $hb[1];
}

sub save {
 my ($s,$name)=@_;
 open(D, ">".$name) || return 0;
 print D $s;
 close D ||return 0;
 return 1;
}

sub load {
 my ($name)=@_;
 open(D, "<".$name) || return '';
 my $s;
 read D,$s,999999;
 close D || return '';
 return $s;
}

sub parse {
 my ($x)=@_;
 $_=body($x);
 s/[\n\r\s]+/ /mg;
 s/>\s+</></mg;
 return $_;
}

sub strip {
 ($_)=@_;
 #extra
 s/<(img)([^a-z>][^>]*|)>//mgi;
 s/<(script)([^a-z>][^>]*|)>[^>]*?<\/script>//mgi;
 s/<(style)([^a-z>][^>]*|)>[^>]*?<\/style>//mgi;
 #normal
 s/<(b|body|html|meta|head|font)([^a-z>][^>]*|)>//mgi;
 s/<\/(b|body|html|head|font)([^a-z>][^>]*|)>//mgi;
# s/<(table|td)([^a-z>][^>]*|)>/<$1>/mgi;
 s/>\s+</></mg;
 return $_;
}
# OBJECT

1;